Skip site navigation (1)Skip section navigation (2)
Date:      Wed, 17 Jul 2013 06:29:42 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-user@freebsd.org
Subject:   svn commit: r253410 - user/pho/stress2/misc
Message-ID:  <201307170629.r6H6TgI7066576@svn.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Wed Jul 17 06:29:41 2013
New Revision: 253410
URL: http://svnweb.freebsd.org/changeset/base/253410

Log:
  Added two regression test for r253189: "Never remove user-wired pages from
  an object when doing msync(MS_INVALIDATE)".
  
  Sponsored by:	EMC / Isilon storage division

Added:
  user/pho/stress2/misc/msync.sh   (contents, props changed)
  user/pho/stress2/misc/wire_no_page.sh   (contents, props changed)

Added: user/pho/stress2/misc/msync.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/msync.sh	Wed Jul 17 06:29:41 2013	(r253410)
@@ -0,0 +1,201 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2013 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# msync(2) / mlockall(2) test scenario.
+# "panic: vm_fault_copy_wired: page missing" seen.
+# http://people.freebsd.org/~pho/stress/log/msync.txt
+# Fixed in r253189.
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/$0 > $dir/msync.c
+cc -o msync -Wall -Wextra msync.c -lpthread || exit 1
+rm -f msync.c
+cd $odir
+
+/tmp/msync
+
+killall msync > /dev/null 2>&1
+rm -f /tmp/msync
+exit
+
+EOF
+#include <sys/types.h>
+#include <err.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <pthread.h>
+#include <pwd.h>
+#include <signal.h>
+#include <sys/mman.h>
+#include <stdint.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <sys/param.h>
+#include <sys/stat.h>
+#include <sys/syscall.h>
+#include <sys/wait.h>
+#include <unistd.h>
+
+int syscallno = SYS_msync;
+#define N (128 * 1024 / (int)sizeof(u_int32_t))
+u_int32_t r[N];
+
+static void
+hand(int i __unused) {	/* handler */
+	_exit(1);
+}
+
+unsigned long
+makearg(void)
+{
+	unsigned int i;
+	unsigned long val;
+
+	val = arc4random();
+	i   = arc4random() % 100;
+	if (i < 20)
+		val = val & 0xff;
+	if (i >= 20 && i < 40)
+		val = val & 0xffff;
+	if (i >= 40 && i < 60)
+		val = (unsigned long)(r) | (val & 0xffff);
+#if defined(__LP64__)
+	if (i >= 60) {
+		val = (val << 32) | arc4random();
+		if (i > 80)
+			val = val & 0x00007fffffffffffUL;
+	}
+#endif
+
+	return(val);
+}
+
+void *
+calls(void *arg __unused)
+{
+	int i, num;
+	unsigned long arg1, arg2, arg3;
+
+	usleep(1000);
+	num = syscallno;
+	for (i = 0; i < 500; i++) {
+		arg1 = makearg();
+		arg2 = makearg();
+#if 0
+		arg3 = makearg();
+		arg3 = arg3 & ~MS_INVALIDATE;	/* No problem seen */
+#else
+		arg3 = MS_INVALIDATE;		/* panic */
+#endif
+
+#if 0
+		fprintf(stderr, "%2d : syscall(%3d, 0x%lx, 0x%lx, 0x%lx)\n",
+			i, num, arg1, arg2, arg3);
+		usleep(50000);
+#endif
+		alarm(1);
+		syscall(num, arg1, arg2, arg3);
+		num = 0;
+	}
+
+	return (0);
+}
+void
+wd(void)
+{
+	int i;
+
+	if (mlockall(MCL_CURRENT | MCL_FUTURE) != 0)
+		err(1, "mlockall failed");
+
+	for (i = 0; i < 800; i++) {
+		if (fork() == 0) {
+			usleep(20000);
+			_exit(0);
+		}
+		wait(NULL);
+		usleep(100000);
+	}
+
+	_exit(0);
+}
+
+int
+main(void)
+{
+	struct passwd *pw;
+	pthread_t cp[50];
+	int i, j;
+
+	if (fork() == 0)
+		wd();
+
+	if ((pw = getpwnam("nobody")) == NULL)
+		err(1, "no such user: nobody");
+
+	if (setgroups(1, &pw->pw_gid) ||
+	    setegid(pw->pw_gid) || setgid(pw->pw_gid) ||
+	    seteuid(pw->pw_uid) || setuid(pw->pw_uid))
+		err(1, "Can't drop privileges to \"nobody\"");
+	endpwent();
+
+	signal(SIGALRM, hand);
+	signal(SIGILL,  hand);
+	signal(SIGFPE,  hand);
+	signal(SIGSEGV, hand);
+	signal(SIGBUS,  hand);
+	signal(SIGURG,  hand);
+	signal(SIGSYS,  hand);
+	signal(SIGTRAP, hand);
+
+	alarm(180);
+	for (i = 0; i < 8000; i++) {
+		if (fork() == 0) {
+			arc4random_stir();
+			for (j = 0; j < N; j++)
+				r[j] = arc4random();
+			for (j = 0; j < 50; j++) 
+				if (pthread_create(&cp[j], NULL, calls, NULL) != 0)
+					perror("pthread_create");
+
+			for (j = 0; j < 50; j++) 
+				pthread_join(cp[j], NULL);
+			_exit(0);
+		}
+		wait(NULL);
+	}
+
+	return (0);
+}

Added: user/pho/stress2/misc/wire_no_page.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/wire_no_page.sh	Wed Jul 17 06:29:41 2013	(r253410)
@@ -0,0 +1,105 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2013 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Test scenario by kib@
+
+# "panic: vm_page_set_invalid: page 0xc3dfe8c0 is busy" seen.
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/$0 > $dir/wire_no_page.c
+cc -o wire_no_page -Wall -Wextra wire_no_page.c -lpthread || exit 1
+rm -f wire_no_page.c
+cd $odir
+
+cp /tmp/wire_no_page /tmp/wire_no_page2
+for i in `jot 100`; do
+	for j in `jot 50`; do
+		/tmp/wire_no_page /tmp/wire_no_page2 &
+	done
+	for j in `jot 50`; do
+		wait
+	done
+done
+
+rm -f /tmp/wire_no_page /tmp/wire_no_page2
+exit
+
+EOF
+/* $Id: wire_no_page.c,v 1.1 2013/05/17 07:50:30 kostik Exp kostik $ */
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/fcntl.h>
+#include <sys/mman.h>
+#include <sys/stat.h>
+#include <err.h>
+#include <unistd.h>
+
+int
+main(int argc, char *argv[])
+{
+	struct stat st;
+	char *p1, *p2;
+	size_t len;
+	pid_t child;
+	int error, fd;
+
+	if (argc < 2)
+		errx(1, "file name ?");
+	fd = open(argv[1], O_RDWR);
+	if (fd == -1)
+		err(1, "open %s", argv[1]);
+	error = fstat(fd, &st);
+	if (error == -1)
+		err(1, "stat");
+	len = round_page(st.st_size);
+	p1 = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
+	if ((void *)p1 == MAP_FAILED)
+		err(1, "mmap");
+	error = mlock(p1, len);
+	if (error == -1)
+		err(1, "mlock");
+	p2 = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
+	if ((void *)p2 == MAP_FAILED)
+		err(1, "mmap");
+	error = msync(p2, len, MS_SYNC | MS_INVALIDATE);
+	if (error == -1)
+		err(1, "msync");
+	child = fork();
+	if (child == -1)
+		err(1, "fork");
+	else if (child == 0)
+		_exit(0);
+
+	return (0);
+}



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201307170629.r6H6TgI7066576>